function x_out = saturateStates(x_in,snake)

%Saturating all angular integrations to be in the space -pi, pi

%Joint angles
theta     =  x_in(8 : 6+snake.n); 

%Desired angles of base link
eta_d     =  x_in(12+2*snake.n+10 : 17+2*snake.n + 10);

%Desired angles of joints
theta_d   =  x_in(18+2*snake.n+10 : 16+3*snake.n + 10);

for i = 1:snake.n-1
    if theta(i) > pi
        theta(i) = theta(i) - 2*pi;
    elseif theta(i) < -pi
        theta(i) = theta(i) + 2*pi;
    end
end

% Saturating desired angle of joints to min -pi, max pi
for i = 1:snake.n-1
    if theta_d(i) > pi
        theta_d(i) = pi;
    elseif theta_d(i) < -pi
        theta_d(i) = -pi;
    end
end


x_in(8 : 6+snake.n) = theta;
x_in(12+2*snake.n+10 : 17+2*snake.n + 10) = eta_d;
x_in(18+2*snake.n+10 : 16+3*snake.n + 10) = theta_d;

%saturating adaptive integrators
gamma_hat = x_in(11+2*snake.n+1 : 11+2*snake.n+5);
sat = abs(gamma_hat) > 50;
gamma_hat(sat) = 50*sign(gamma_hat(sat));
x_in(11+2*snake.n+1 : 11+2*snake.n+5) = gamma_hat;
    
gamma_hat_link = x_in(16+2*snake.n+1 : 16+2*snake.n+5);
sat = abs(gamma_hat_link) > 50;
gamma_hat_link(sat) = 50*sign(gamma_hat_link(sat));
x_in(16+2*snake.n+1 : 16+2*snake.n+5) = gamma_hat_link;

x_out = x_in;

end

